'use strict';

var t = require('@babel/types');
var Option = require('effect/Option');
var babel_constructors = require('./babel.constructors');

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var t__namespace = /*#__PURE__*/_interopNamespaceCompat(t);
var Option__namespace = /*#__PURE__*/_interopNamespaceCompat(Option);

const isReactNativeImport = (binding) => {
    return (t__namespace.isImportSpecifier(binding.path.node) &&
        t__namespace.isImportDeclaration(binding.path.parent) &&
        binding.path.parent.source.value === 'react-native');
};
const isReactNativeRequire = (binding) => {
    return (t__namespace.isCallExpression(binding.path.node) &&
        t__namespace.isIdentifier(binding.path.node.callee, { name: 'require' })
    // binding.path.parent.source.value === 'react-native'
    );
};
const isReactRequire = (node) => {
    return node.pipe(Option__namespace.filterMap(([, node]) => t__namespace.isIdentifier(node.callee, { name: 'require' }) &&
        t__namespace.isStringLiteral(node.arguments[0], { value: 'react' })
        ? Option__namespace.some(true)
        : Option__namespace.none()));
};
const isReactInteropRequire = (node) => {
    return node.pipe(Option__namespace.flatMap(([, node]) => {
        if (
        // const <name> = _interopRequireDefault(require("react"))
        t__namespace.isIdentifier(node.callee, { name: '_interopRequireDefault' }) &&
            t__namespace.isCallExpression(node.arguments[0]) &&
            t__namespace.isIdentifier(node.arguments[0].callee, { name: 'require' }) &&
            t__namespace.isStringLiteral(node.arguments[0].arguments[0], {
                value: 'react',
            })) {
            return Option__namespace.some(true);
        }
        return Option__namespace.none();
    }));
};
const valueIsPrimitive = (value) => {
    return (typeof value === 'string' || typeof value === 'number' || typeof value === 'boolean');
};
const hasJsxAttribute = (element, name, value) => {
    if (!t__namespace.isJSXElement(element))
        return false;
    return element.openingElement.attributes.some((x) => t__namespace.isJSXAttribute(x, {
        name: t__namespace.jsxIdentifier(name),
        value: t__namespace.jsxExpressionContainer(babel_constructors.createPrimitiveExpression(value)),
    }));
};

exports.hasJsxAttribute = hasJsxAttribute;
exports.isReactInteropRequire = isReactInteropRequire;
exports.isReactNativeImport = isReactNativeImport;
exports.isReactNativeRequire = isReactNativeRequire;
exports.isReactRequire = isReactRequire;
exports.valueIsPrimitive = valueIsPrimitive;
//# sourceMappingURL=babel.predicates.js.map
