import { ParseResult } from '@babel/parser';
import { Binding } from '@babel/traverse';
import * as t from '@babel/types';
import * as Effect from 'effect/Effect';
import * as Option from 'effect/Option';
import { Tree, TreeNode } from '@native-twin/helpers/tree';
import { JSXElementNode } from '../../models';
import { type MappedComponent } from '../../utils/component.maps';
import { JSXElementNodePath, type JSXElementTree, type JSXMappedAttribute } from '../jsx.types';
export declare const getJSXElementSource: (path: JSXElementNodePath) => {
    kind: string;
    source: string;
} | {
    kind: string;
    source: string;
};
export declare const getBindingImportSource: (binding: Binding) => Option.Option<{
    kind: string;
    source: string;
}>;
/**
 * @category Transformer
 * @domain Babel
 * Extract {@link JSXMappedAttribute[]} list from a jsx Attribute
 * */
export declare const extractMappedAttributes: (node: t.JSXElement) => JSXMappedAttribute[];
/**
 * @domain Babel
 * @description Extract the {@link t.JSXAttribute[]} from any {@link t.JSXElement}
 * */
export declare const getJSXElementAttrs: (element: t.JSXElement) => t.JSXAttribute[];
/**
 * @domain Babel
 * @description Extract the {@link JSXMappedAttribute} from any {@link t.JSXAttribute}
 * */
export declare const extractStyledProp: (attribute: t.JSXAttribute, config: MappedComponent) => JSXMappedAttribute | null;
export declare const getJSXElementName: (openingElement: t.JSXOpeningElement) => Option.Option<string>;
export declare const getBabelJSXElementChildsCount: (node: t.JSXElement) => number;
export declare const getAstTrees: (ast: ParseResult<t.File>, filename: string) => Effect.Effect<Tree<JSXElementTree>[], never, never>;
export declare const gelBabelJSXElementChildLeaves: (path: JSXElementNodePath, parent: TreeNode<JSXElementTree>) => void;
export declare const getJSXCompiledTreeRuntime: (leave: JSXElementNode, parentLeave: Option.Option<JSXElementNode>) => {
    leave: JSXElementNode;
    runtimeSheet: import("@native-twin/css/jsx").RuntimeComponentEntry[];
};
//# sourceMappingURL=jsx.maps.d.ts.map