import * as t from '@babel/types';
import { pipe } from 'effect/Function';
import * as Predicate from 'effect/Predicate';

const isJSXElement = pipe((node) => t.isJSXElement(node), Predicate.mapInput((node) => node));
const isJSXElementNode = (node) => t.isJSXElement(node);
const isCallExpression = (node) => t.isNode(node) && t.isCallExpression(node);
const isVariableDeclaratorPath = (path) => path.isVariableDeclarator();
const variableDeclaratorIsRequire = pipe((path) => path.isCallExpression());
const isImportSpecifier = pipe((path) => path.isImportSpecifier());
const isImportDeclaration = pipe((path) => path.isImportDeclaration());
const isJSXElementPath = (node) => node.isJSXElement();
const isJSXAttribute = (node) => t.isJSXAttribute(node);
const isJSXAttributePath = (node) => node.isJSXAttribute();

export { isCallExpression, isImportDeclaration, isImportSpecifier, isJSXAttribute, isJSXAttributePath, isJSXElement, isJSXElementNode, isJSXElementPath, isVariableDeclaratorPath, variableDeclaratorIsRequire };
//# sourceMappingURL=jsx.predicates.js.map
