import * as t from '@babel/types';
import * as Equal from 'effect/Equal';
import * as Hash from 'effect/Hash';
import * as Option from 'effect/Option';
import { ChildsSheet, RuntimeComponentEntry } from '@native-twin/css/jsx';
import { TreeNode } from '@native-twin/helpers/tree';
import { JSXElementTree, JSXMappedAttribute } from '../jsx/jsx.types';
import { NativeTwinService } from '../services';
export declare class JSXElementNodeKey implements Equal.Equal {
    readonly path: t.JSXElement;
    readonly filename: string;
    constructor(path: t.JSXElement, filename: string);
    [Hash.symbol](): number;
    [Equal.symbol](that: unknown): boolean;
}
export declare const jsxElementNodeKey: (path: t.JSXElement, filename: string) => JSXElementNodeKey;
interface JSXElementNodeInit {
    leave: TreeNode<JSXElementTree>;
    order: number;
    filename: string;
    runtimeData: JSXMappedAttribute[];
    twin: NativeTwinService['Type'];
}
export declare class JSXElementNode implements Equal.Equal {
    readonly leave: TreeNode<JSXElementTree>;
    readonly order: number;
    readonly filename: string;
    readonly id: string;
    readonly runtimeData: JSXMappedAttribute[];
    readonly entries: RuntimeComponentEntry[];
    readonly childEntries: ChildsSheet;
    constructor({ filename, leave, order, runtimeData, twin }: JSXElementNodeInit);
    get source(): {
        kind: string;
        source: string;
    };
    get parentSize(): number;
    get parentLeave(): Option.Option<TreeNode<JSXElementTree>>;
    get parentID(): Option.Option<string>;
    get path(): t.JSXElement;
    get attributes(): t.JSXAttribute[];
    get openingElement(): t.JSXOpeningElement;
    get elementName(): string;
    [Hash.symbol](): number;
    [Equal.symbol](that: unknown): boolean;
}
export {};
//# sourceMappingURL=JSXElement.model.d.ts.map