import * as Effect from 'effect/Effect';
import { pipe } from 'effect/Function';
import * as HashMap from 'effect/HashMap';
import * as Ref from 'effect/Ref';

class StyleSheetModel {
    value;
    constructor(value) {
        this.value = value;
    }
    add(id, sheet) {
        return Effect.sync(() => pipe(this.value, Ref.update(HashMap.set(id, sheet))));
    }
    get(id) {
        return pipe(this.value, Ref.get, Effect.map(HashMap.get(id)));
    }
}
const makeBabelStyleSheet = Effect.andThen(Ref.make(HashMap.empty()), (value) => new StyleSheetModel(value));

export { StyleSheetModel, makeBabelStyleSheet };
//# sourceMappingURL=StyleSheet.model.js.map
