import type { JsTransformerConfig, JsTransformOptions, TransformResponse } from 'metro-transform-worker';
export type BabelTransformerFn = (params: {
    src: string;
    filename: string;
    options: BabelTransformerOptions;
}) => Promise<any>;
export interface NativeTwinTransformerOpts extends JsTransformerConfig {
    transformerPath?: string;
    originalTransformerPath?: string;
    allowedFiles: string[];
    tailwindConfigPath: string;
    outputDir: string;
    inputCSS: string;
    outputCSS: string;
    platformOutputs: string[];
}
export type TwinTransformFn = (config: NativeTwinTransformerOpts, projectRoot: string, filename: string, data: Buffer, options: JsTransformOptions) => Promise<TransformResponse>;
export interface BabelTransformerOptions {
    customTransformOptions: {
        routerRoot: string;
        inputCSS: string;
        outputCSS: string;
        environment: string;
        baseUrl: string;
    };
    dev: boolean;
    hot: boolean;
    platform: string;
    type: string;
    projectRoot: string;
}
export interface BabelTransformerConfig {
    options: BabelTransformerOptions;
    filename: string;
    outputCSS: string;
    inputCSS: string;
    code: string;
    allowedPaths: string[];
    platform: string;
    generate: {
        tree: boolean;
        componentID: boolean;
        styledProps: boolean;
        templateStyles: boolean;
        order: boolean;
    };
}
//# sourceMappingURL=metro.models.d.ts.map