import * as t from '@babel/types';
import * as Context from 'effect/Context';
import * as HashMap from 'effect/HashMap';
import * as Layer from 'effect/Layer';
import { RuntimeComponentEntry } from '@native-twin/css/jsx';
import { JSXElementNode } from '../models';
import { BabelTransformerConfig, BabelTransformerFn } from '../models/metro.models';
import { NativeTwinService } from './NativeTwin.service';
declare const MetroCompilerContext_base: Context.TagClass<MetroCompilerContext, "metro/babel/transformer-context", BabelTransformerConfig>;
export declare class MetroCompilerContext extends MetroCompilerContext_base {
    static make: ({ filename, options, src }: Parameters<BabelTransformerFn>[0], generate: BabelTransformerConfig["generate"]) => Layer.Layer<MetroCompilerContext, never, NativeTwinService>;
}
declare const BabelTransformerService_base: Context.TagClass<BabelTransformerService, "babel/TransformerService", {
    isNotAllowedPath(path: string): boolean;
    isCssFile: (filePath: string) => boolean;
    transform(code: string): Promise<any>;
    transformLeave: (trees: HashMap.HashMap<string, JSXElementNode>) => HashMap.HashMap<string, {
        leave: JSXElementNode;
        runtimeSheet: RuntimeComponentEntry[];
        runtimeAST: t.Expression | null | undefined;
    }>;
}>;
export declare class BabelTransformerService extends BabelTransformerService_base {
}
export declare const BabelTransformerServiceLive: Layer.Layer<BabelTransformerService, never, MetroCompilerContext>;
export {};
//# sourceMappingURL=MetroCompilerContext.service.d.ts.map