import * as Context from 'effect/Context';
import * as Effect from 'effect/Effect';
import * as Layer from 'effect/Layer';
import { getUserTwinConfig, setupNativeTwin } from '../jsx/twin';

class NativeTwinService extends Context.Tag('babel/twin-service')() {
    static make = (options) => Layer.scoped(NativeTwinService, Effect.gen(function* () {
        const platform = options.platform;
        const twinConfig = getUserTwinConfig(options.projectRoot, {
            engine: 'hermes',
            isDev: options.dev,
            isServer: options.platform === 'web',
            platform: options.platform,
        });
        // console.log('DEFINED_PREFLIGHT: ', twinConfig.preflight);
        const preflight = {};
        if (options.platform === 'web') {
            twinConfig.mode = 'web';
        }
        // twinConfig.preflight = {};
        const twin = setupNativeTwin(twinConfig, {
            engine: 'hermes',
            isDev: options.dev,
            isServer: options.platform === 'web',
            platform: options.platform,
        });
        return {
            tw: twin,
            config: twinConfig,
            preflight,
            context: {
                baseRem: twin.config.root.rem ?? 16,
                platform,
            },
        };
    }));
}

export { NativeTwinService };
//# sourceMappingURL=NativeTwin.service.js.map
