import * as Context from 'effect/Context';
import * as Effect from 'effect/Effect';
import * as Ref from 'effect/Ref';
import * as Scope from 'effect/Scope';
import { JSXElementNode } from '../models/JSXElement.model';
interface State {
    acquire(): Effect.Effect<JSXElementNode[], never, Scope.Scope>;
    acquired(): Effect.Effect<JSXElementNode[]>;
    insert(node: JSXElementNode): Effect.Effect<void>;
}
export declare class TransformerState implements State {
    readonly ref: Ref.Ref<JSXElementNode[]>;
    constructor(ref: Ref.Ref<JSXElementNode[]>);
    acquire(): Effect.Effect<JSXElementNode[], never, Scope.Scope>;
    acquired(): Effect.Effect<JSXElementNode[]>;
    released(): Effect.Effect<JSXElementNode[]>;
    insert(node: JSXElementNode): Effect.Effect<JSXElementNode>;
    static make: () => Effect.Effect<TransformerState>;
}
declare const TransformerServiceTypeId: unique symbol;
type TransformerServiceTypeId = typeof TransformerServiceTypeId;
interface TransformerService {
    readonly [TransformerServiceTypeId]: TransformerServiceTypeId;
}
export declare const TransformerService: TransformerService;
export declare const TransformerStateTag: Context.Tag<TransformerService, TransformerService>;
export {};
//# sourceMappingURL=TransformerState.service.d.ts.map