import * as Context from 'effect/Context';
import * as Effect from 'effect/Effect';
import { pipe } from 'effect/Function';
import * as Ref from 'effect/Ref';

class TransformerState {
    ref;
    constructor(ref) {
        this.ref = ref;
    }
    acquire() {
        return pipe(Ref.get(this.ref), Effect.zipRight(this.acquired()), Effect.uninterruptible);
    }
    acquired() {
        return pipe(Ref.get(this.ref));
    }
    released() {
        return pipe(Ref.get(this.ref));
    }
    insert(node) {
        return Ref.modify(this.ref, (nodes) => [node, nodes]);
    }
    static make = () => {
        return pipe(Ref.make([]), Effect.map((ref) => new TransformerState(ref)));
    };
}
const TransformerServiceTypeId = Symbol.for('effect/Reloadable/transformer-state');
const TransformerService = {
    [TransformerServiceTypeId]: TransformerServiceTypeId,
};
const TransformerStateTag = Context.GenericTag('babel/transformer-state-context');

export { TransformerService, TransformerState, TransformerStateTag };
//# sourceMappingURL=TransformerState.service.js.map
