import jitiFactory from 'jiti';
import { transform } from 'sucrase';

let jiti = null;
function lazyJiti() {
    return (jiti ??
        (jiti = jitiFactory(__filename, {
            interopDefault: true,
            transform: (opts) => {
                return transform(opts.source, {
                    transforms: ['typescript', 'imports'],
                });
            },
        })));
}
function requireJS(path) {
    const config = (function () {
        try {
            return path ? require(path) : {};
        }
        catch {
            return lazyJiti()(path);
        }
    })();
    return config.default ?? config;
}

export { requireJS };
//# sourceMappingURL=load-js.js.map
