'use strict';

var generate = require('@babel/generator');
var t = require('@babel/types');
var RA = require('effect/Array');
var Function = require('effect/Function');
var jsx = require('@native-twin/css/jsx');
var babel = require('../../babel');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var generate__default = /*#__PURE__*/_interopDefaultCompat(generate);
var t__namespace = /*#__PURE__*/_interopNamespaceCompat(t);
var RA__namespace = /*#__PURE__*/_interopNamespaceCompat(RA);

const getElementEntries = (props, twin, ctx) => {
    return Function.pipe(props, RA__namespace.map(({ value, prop, target }) => {
        let classNames = '';
        let templateExpression = null;
        if (t__namespace.isStringLiteral(value)) {
            classNames = value.value;
        }
        else {
            const cooked = babel.templateLiteralToStringLike(value);
            classNames = cooked.strings;
            templateExpression = generate__default.default(cooked.expressions).code;
        }
        const entries = twin(classNames);
        const runtimeEntries = Function.pipe(entries, RA__namespace.dedupeWith((a, b) => a.className === b.className), RA__namespace.map((x) => jsx.compileSheetEntry(x, ctx)), jsx.sortSheetEntries);
        return {
            classNames,
            prop,
            target,
            templateLiteral: templateExpression,
            entries: runtimeEntries,
            templateEntries: [],
            // childEntries: pipe(
            //   runtimeEntries,
            //   RA.filter((x) => isChildEntry(x)),
            // ),
            rawSheet: jsx.getGroupedEntries(runtimeEntries),
        };
    }));
};

exports.getElementEntries = getElementEntries;
//# sourceMappingURL=twin.entries.js.map
