'use strict';

var Effect = require('effect/Effect');
var Function = require('effect/Function');
var HashMap = require('effect/HashMap');
var Ref = require('effect/Ref');

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var Effect__namespace = /*#__PURE__*/_interopNamespaceCompat(Effect);
var HashMap__namespace = /*#__PURE__*/_interopNamespaceCompat(HashMap);
var Ref__namespace = /*#__PURE__*/_interopNamespaceCompat(Ref);

class StyleSheetModel {
    value;
    constructor(value) {
        this.value = value;
    }
    add(id, sheet) {
        return Effect__namespace.sync(() => Function.pipe(this.value, Ref__namespace.update(HashMap__namespace.set(id, sheet))));
    }
    get(id) {
        return Function.pipe(this.value, Ref__namespace.get, Effect__namespace.map(HashMap__namespace.get(id)));
    }
}
const makeBabelStyleSheet = Effect__namespace.andThen(Ref__namespace.make(HashMap__namespace.empty()), (value) => new StyleSheetModel(value));

exports.StyleSheetModel = StyleSheetModel;
exports.makeBabelStyleSheet = makeBabelStyleSheet;
//# sourceMappingURL=StyleSheet.model.js.map
