'use strict';

var FiberId = require('effect/FiberId');
var LogLevel = require('effect/LogLevel');
var Logger = require('effect/Logger');
var util = require('util');

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var FiberId__namespace = /*#__PURE__*/_interopNamespaceCompat(FiberId);
var LogLevel__namespace = /*#__PURE__*/_interopNamespaceCompat(LogLevel);
var Logger__namespace = /*#__PURE__*/_interopNamespaceCompat(Logger);

const BabelLogger = Logger__namespace.make((options) => {
    const message = util.inspect({
        message: options.message,
        date: options.date,
        fiberId: FiberId__namespace.threadName(options.fiberId),
    }, false, null, true);
    switch (options.logLevel) {
        case LogLevel__namespace.Trace:
            console.trace(message);
            return;
        case LogLevel__namespace.Debug:
            console.debug(message);
            return;
        case LogLevel__namespace.Warning:
            console.warn(message);
            return;
        case LogLevel__namespace.Error:
        case LogLevel__namespace.Fatal:
            console.error(message);
            return;
        default:
            console.info(message);
            return;
    }
});

exports.BabelLogger = BabelLogger;
//# sourceMappingURL=Logger.service.js.map
