'use strict';

var Context = require('effect/Context');
var Effect = require('effect/Effect');
var Function = require('effect/Function');
var Ref = require('effect/Ref');

function _interopNamespaceCompat(e) {
    if (e && typeof e === 'object' && 'default' in e) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n.default = e;
    return Object.freeze(n);
}

var Context__namespace = /*#__PURE__*/_interopNamespaceCompat(Context);
var Effect__namespace = /*#__PURE__*/_interopNamespaceCompat(Effect);
var Ref__namespace = /*#__PURE__*/_interopNamespaceCompat(Ref);

class TransformerState {
    ref;
    constructor(ref) {
        this.ref = ref;
    }
    acquire() {
        return Function.pipe(Ref__namespace.get(this.ref), Effect__namespace.zipRight(this.acquired()), Effect__namespace.uninterruptible);
    }
    acquired() {
        return Function.pipe(Ref__namespace.get(this.ref));
    }
    released() {
        return Function.pipe(Ref__namespace.get(this.ref));
    }
    insert(node) {
        return Ref__namespace.modify(this.ref, (nodes) => [node, nodes]);
    }
    static make = () => {
        return Function.pipe(Ref__namespace.make([]), Effect__namespace.map((ref) => new TransformerState(ref)));
    };
}
const TransformerServiceTypeId = Symbol.for('effect/Reloadable/transformer-state');
const TransformerService = {
    [TransformerServiceTypeId]: TransformerServiceTypeId,
};
const TransformerStateTag = Context__namespace.GenericTag('babel/transformer-state-context');

exports.TransformerService = TransformerService;
exports.TransformerState = TransformerState;
exports.TransformerStateTag = TransformerStateTag;
//# sourceMappingURL=TransformerState.service.js.map
